
#include <stdio.h>

#define		MAX						5	//	 ũ
#define		UNDER_CONSTRUCTION		-1	//	  ǥ

static int g_Map[MAX][MAX] =
{
	0, 1, 1, 1, UNDER_CONSTRUCTION,
	1, 0, 0, 0, 0,
	1, 0, 0, 0, 0,
	1, UNDER_CONSTRUCTION, 0, 0, 0,
	1, 0, 0, 0, 0
};

/*
	ش   ̵ üũϴ Լ
	1 ϸ ̵ϰ 0 ϸ ̵Ұ ̴.
*/
int MoveableMap(int row, int col);

/*
	ش      üũϴ Լ
	1 ϸ   ϰ 0 ϸ    ̴.
*/
int CheckBoundMap(int row, int col);

/*
	(0,0)  ϴ(MAX - 1, MAX - 1) ϴ
	    ϴ Լ
*/
int SearchDFS(int curRow, int curCol);

int main(void)
{
	//	ʱ Ž ġ  (0,0)̴.
	int wayCnt = SearchDFS(0, 0);

	printf(" : %d\n", wayCnt);

	return 0;
}

/*
	(0,0)  ϴ(MAX - 1, MAX - 1) ϴ 
	    ϴ Լ
*/
int SearchDFS(int curRow, int curCol)
{
	int wayCnt = 0;	//	  

	//	Լ Ż  ϴܿ     θ ãǷ
	//	1 Ѵ.
	if (curRow == (MAX - 1) && curCol == (MAX - 1))
		return 1;

	/*
		curRow, curCol ߽ Ʒ    ִ  θ ã ȴ.
	*/

	//	1. Ʒ Ž
	//	Ʒ   ʿ ִ üũ
	if (CheckBoundMap(curRow + 1, curCol))
	{
		//	Ʒ  ̵  ִ  üũϰ Ž
		if (MoveableMap(curRow + 1,curCol))
			wayCnt += SearchDFS(curRow + 1, curCol);
	}
	
	//	2.  Ž
	//	   ʿ ִ üũ
	if (CheckBoundMap(curRow, curCol + 1))
	{
		//	  ̵  ִ  üũϰ Ž
		if (MoveableMap(curRow, curCol + 1))
			wayCnt += SearchDFS(curRow, curCol + 1);
	}

	return wayCnt;
}

/*
	ش      üũϴ Լ
	1 ϸ   ϰ 0 ϸ    ̴.
*/	
int CheckBoundMap(int row, int col)
{
	if (0 <= row && row < MAX &&
		0 <= col && col < MAX)
		return 1;

	return 0;
}

/*
	ش   ̵ üũϴ Լ
	1 ϸ ̵ϰ 0 ϸ ̵Ұ ̴.
*/
int MoveableMap(int row, int col)
{
	//	 ƴϸ ̵ϴ.
	if (g_Map[row][col] != UNDER_CONSTRUCTION)
		return 1;
	else
		return 0;
}

